
<!--
    Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)
    
    SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import Modal from '@/components/general/Modal.vue';
import { computed, inject, ref } from 'vue';
import { useDashboardStore } from '@/stores/dashboard';
import { storeToRefs } from 'pinia';
import { request } from '@/lib/request';
import type { folder } from '@/types/dashboard';

const store = useDashboardStore();
const { folderParent, selectedItems, folders } = storeToRefs(store);

const emits = defineEmits<{
    (e: 'submit'): void,
    (e: 'cancel'): void
}>();

let configuration = inject<any>('configuration');
const submit = async () => {
    const data = {
        folder: folderParent.value,
        panes: selectedItems.value
    }
    const url = configuration.apiServer + `/api/overview/pane/move`;
    const response = await request('PUT', url, data, 'application/json', false, true);
    if (response && response.success) {
        store.reset();
        emits(`submit`);
    } else {
        console.error("ERROR");
    }
};
const cancel = () => {
    store.reset();
    emits(`cancel`);
};

const flattedFolders = computed(() => {
    let array: folder[] = [];
    folders.value?.forEach((folder) => {
        array.push(folder);
        const preparedSubfolders = folder.subfolders ? folder.subfolders?.map(({ name, ...subfolder }) => { return { ...subfolder, name: "--> " + name } }) : [];
        array.push(...preparedSubfolders);
    })
    return array;
    //return folders.value?.map(({subfolders,...folder})=>{ return { ...folder, subfolders: subfolders?.map(({name, ...subfolder})=>{return {...subfolder, name: "--> "+name } })}});
});
</script>
<template>
    <Modal :header="$t('dashboardPage.folder.move.label')" :labelSubmit="$t('dashboardPage.folder.move.submit')"
        @submit="submit" :labelCancel="$t('general.buttons.cancel')" @cancel="cancel">
        <form @submit.prevent>
            <div>
                <select
                    class="w-full border border-gray-300 px-2 py-1.5 focus:border-accent1-default rounded-md focus-visible:outline-0"
                    v-model="folderParent">
                    <option value="">{{ $t('dashboardPage.folder.create.none') }}</option>
                    <option :key="index" :value="e.id" v-for="e, index in flattedFolders">{{ e.name }}</option>
                </select>
            </div>
        </form>
    </Modal>
</template>